• 【二分答案】 【POJ3497】 【Northwestern Europe 2007】 Assemble 组装电脑


    Assemble
    Time Limit: 1000MS   Memory Limit: 65536K
    Total Submissions: 3171   Accepted: 1013

    Description

    Recently your team noticed that the computer you use to practice for programming contests is not good enough anymore. Therefore, you decide to buy a new computer.

    To make the ideal computer for your needs, you decide to buy separate components and assemble the computer yourself. You need to buy exactly one of each type of component.

    The problem is which components to buy. As you all know, the quality of a computer is equal to the quality of its weakest component. Therefore, you want to maximize the quality of the component with the lowest quality, while not exceeding your budget.

    Input

    On the first line one positive number: the number of testcases, at most 100. After that per testcase:

    • One line with two integers: 1 ≤ n ≤ 1 000, the number of available components and 1 ≤ b ≤ 1 000 000 000, your budget.

    • n lines in the following format: “type name price quality”, where type is a string with the type of the component, name is a string with the unique name of the component, price is an integer (0 ≤price ≤ 1 000 000) which represents the price of the component and quality is an integer (0 ≤ quality ≤ 1 000 000 000) which represents the quality of the component (higher is better). The strings contain only letters, digits and underscores and have a maximal length of 20 characters.

    Output

    Per testcase:

    • One line with one integer: the maximal possible quality.

    Sample Input

    1
    18 800
    processor 3500_MHz 66 5
    processor 4200_MHz 103 7
    processor 5000_MHz 156 9
    processor 6000_MHz 219 12
    memory 1_GB 35 3
    memory 2_GB 88 6
    memory 4_GB 170 12
    mainbord all_onboard 52 10
    harddisk 250_GB 54 10
    harddisk 500_FB 99 12
    casing midi 36 10
    monitor 17_inch 157 5
    monitor 19_inch 175 7
    monitor 20_inch 210 9
    monitor 22_inch 293 12
    mouse cordless_optical 18 12
    mouse microsoft 30 9
    keyboard office 4 10

    Sample Output

    9


    很久没做的二分答案的题目了,很好的二分答案练手题目。

    这种最大中最小,最小中最大一般都是二分答案
    然后判断答案的正确与否

    代码如下:
    #include<cstdio>
    #include<cstring>
    #include<cstdlib>
    using namespace std;
    typedef struct node
    {
    	char name[30];
    	char type[30];
    	int price;
    	int quality;
    	int TYPE;
    }node;
    node thing[1010];
    int flag[1010];
    int anslist[1010]; 
    int n,b,cnt,ans;
    int cmp(const void *i,const void *j)
    {
    	node *ii=(node *)i,*jj=(node *)j;
    	return strcmp(ii->type,jj->type);
    }
    int cmp3(const void *i,const void *j)
    {
    	return *(int *)i-*(int *)j;
    }
    int OK(int std)
    {
    	int sum=0,PRICE; 
    	for(int i=1;i<=cnt;i++)
    	 {
    	 	PRICE=1000001;
    	 for(int j=flag[i];j<flag[i+1];j++)
    	   		if(thing[j].quality>=std)
    	   		 if(thing[j].price<PRICE) PRICE=thing[j].price;
    	    if(PRICE==1000001) return 0;
    		else sum=sum+PRICE; 
    	}
    	if(sum<=b) return 1;
    	else return 0;
    }
    int getans()
    {
    	int i,j,m;
    	i=1;j=n;
    	while(i<j)
    	{
    		m=(i+j)/2+1;
    		if(OK(anslist[m])) i=m;
    		else j=m-1;  
    	}	
    	ans=i;
    }
    int main()
    {
    //	freopen("a.in","r",stdin);
    //	freopen("a.out","w",stdout);
    	int T;
    	scanf("%d",&T);
    	while(T--)
    	{
    		cnt=1;
    		scanf("%d%d
    ",&n,&b);
    		for(int i=1;i<=n;i++)
    		{
    			scanf("%s %s %d %d
    ",thing[i].type,thing[i].name,&thing[i].price,&thing[i].quality);	
    			anslist[i]=thing[i].quality;
    		}
    		qsort(thing+1,n,sizeof(thing[1]),cmp);
    		qsort(anslist+1,n,sizeof(anslist[1]),cmp3); 
    		flag[cnt]=1;
    		for(int i=2;i<=n;i++)
    		{
    			
    			if(strcmp(thing[i].type,thing[i-1].type)==0) thing[i-1].TYPE=cnt;
    			else 
    			{
    				thing[i-1].TYPE=cnt;
    				cnt++;
    				flag[cnt]=i;
    			}
    		}
    		flag[cnt+1]=n+1;
    			thing[n].TYPE=cnt;
    		getans();	
    		printf("%d
    ",anslist[ans]);
    	}
    	return 0;
    }

    附书上解释:

    【分析】

    在《入门经典》一书中,我们曾提到过,解决“最小值最大”的常用方法是二分答案。假设答案为x,如何判断这个x是最小还是最大呢?删除品质因子小于x的所有配件,如果可以组装出一台不超过b元的电脑,那么标准答案ans≥x,否则ans<x

    如何判断是否可以组装出满足预算约束的电脑呢?很简单,每一类配件选择最便宜的一个即可。如果这样选都还超预算的话,就不可能有解了。代码如下。


  • 相关阅读:
    使用Gson将对象类转成Json对象时出现u003d的问题
    spark 关联source
    FutureTask demo
    mybatis batchinsert
    spark-shell下有提示了,但是发现不能退格
    why big data
    MySQL buffer pool中的三种链
    MySQL 性能监控 4 大指标
    实战演示疑惑 mysql insert到底加什么锁
    MySQL锁(行锁、表锁、页锁、乐观锁、悲观锁等)
  • 原文地址:https://www.cnblogs.com/zy691357966/p/5480461.html
Copyright © 2020-2023  润新知